<?php


function memberpagesUpdate()
{
    global $plugin_cf,$plugin_tx,$hjs,$pth,$sl,$cf;
    $o = $text = $error = $olddir = '';

    $hjs .= '<style type="text/css"><!--
.membp_update {
    border:2px red solid;
    padding:1em;
    background:#ffa;
    margin-bottom:10em;
}
.membp_update div {
    max-width:30em;
    margin:0 auto;
}
.membp_update h1 {
    color:red;
    text-align:center;
}
.membp_update p, .membp_update button, .membp_update input{
    color:#600;
    font-size:110%;
    width:100%;
    padding:0;
}
.membp_update input {
    font-weight:bold;
    font-family: Consolas, monospace;
}
.membp_update button {
    line-height:2;
    color:black;
    font-weight:bold;
    display:block;
    text-align:center;
    background:#ccc;
    cursor: pointer;
}
.membp_update form {
    margin:0;
}
.membp_update .error {
    background: #fbe5e2 url("fail.png") no-repeat 10px;
    color: #992213;
    border: 1px solid #f2a197;
}
//--></style>';

    $en = $de = array();
    $en['logfile_bytesimport']  = ' Bytes from old log file imported into new log file.';
    $de['logfile_bytesimport']  = ' Bytes aus alter Logdatei in neue Logdatei importiert.';
    $en['error_logfileimport']  = 'ERROR: Import of log file failed.';
    $de['error_logfileimport']  = 'FEHLER: Import der Logdate nicht gelungen.';
    $en['memberlist_importok']  = '<p>Old members list imported and saved as new list.</p>';
    $de['memberlist_importok']  = '<p>Alte Mitgliederliste importiert und als neue Liste gespeichert.</p>';
    $en['err_memberlistimport'] = 'ERROR: Import of old members list failed. Please check writing permissions and try again.';
    $de['err_memberlistimport'] = 'FEHLER: Import der alten Mitgliederliste fehlgeschlagen. Bitte Schreibrechte überprüfen und  and try again.';
    $en['oldpath_now_newpath']  = '<p>Old members list path has become path for new members list</p>';
    $de['oldpath_now_newpath']  = '<p>Alter Pfad zur Mitgliederliste jetzt als aktueller Pfad eingestellt</p>';
    $en['err_oldpath_newpath']  = '<p>ERROR: New members list path could not be written into config.php. '
                                . 'Please check writing permissions of config.php and start plugin activation again.</p>';
    $de['err_oldpath_newpath']  = '<p>FEHLER: Neuer Pfad zur Mitgliederliste konnte nicht in die config.php geschrieben werden. '
                                . 'Bitte Schreibrechte prüfen und Pluginaktivierung wiederholen.</p>';
    $en['path_memlistchanged']  = '<p>Path for new list changed to ';
    $de['path_memlistchanged']  = '<p>Pfad zu neuen Liste geändert zu ';
    $en['err_path_listchange']  = '<p>ERROR: New members list path could not be written into config.php. '
                                . 'Please check writing permissions of config.php and start plugin activation again.</p>';
    $de['err_path_listchange']  = '<p>FEHLER: Pfad zur neuen Mitgliederlister konnte nicht in die config.php geschreiben werden. '
                                . 'Bitte Schreibrechte bei der config.php prüfen und Pluginsktivierung wiederholen.</p>';
    $en['activation_alert']     = 'Plugin Activation Form';
    $de['activation_alert']     = 'Plugin-Aktivierung';
    $en['activation_click_here']= 'click here to activate plugin';
    $de['activation_click_here']= 'hier klicken zum Aktivieren.';
    $en['activation_explained'] = 'Please check first, if your folder settings and writing permissions are OK.<br>'
                                . 'You can also import data from an old version. '
                                . 'If you don\'t import data from an old version, a new members\' list will be started. '
                                . 'If folder settings, permissions and import are as you want them,';
    $de['activation_explained'] = 'Bitte zuerst prüfen, ob Ordner und Schreibrechte in Ordnung sind.<br>'
                                . 'Die Mitgliederliste aus einer Vorversion kann importiert werden.<br>Nachdem alles geprüft ist,';
    $en['details_explained']    = '<p>Version 3.5 of memberpages saves</p>'
                                . '<ul><li>members list (membersfile.php)</li>'
                                . '<li>log file (log.txt)</li>'
                                . '<li>names of momentarily active members (members.dat)</li>'
                                . '<li>enquiries to become member (new.php)</li>'
                                . '<li>protective .htaccess file (.htaccess)</li></ul>'
                                . '<p>together in the same folder, which is at present: ';
    $de['details_explained']    = '<p>Version 3.5 von Memberpage_XH speichert</p>'
                                . '<ul><li>die Mitgliederlister (membersfile.php)</li>'
                                . '<li>der Logdatei (log.txt)</li>'
                                . '<li>die Namen der gegenwärtig eingeloggten Mitglieder (members.dat)</li>'
                                . '<li>der Anträge auf Mitgliedschaft (new.php)</li>'
                                . '<li>und die gegen Fremdzugriff schützende .htaccess Datei (.htaccess)</li></ul>'
                                . '<p>zusammen im selben Ordner, der gegenwärtig folgender ist: ';
    $en['standard_location']    = ' (standard location)</p>';
    $de['standard_location']    = ' (Standard Ordnereinstellung)</p>';
    $en['changed_location']     = ' (changed location)</p>';
    $de['changed_location']     = ' (Geänderte Ordnereinstellung)</p>';
    $en['newlist_foundat']      = '<p><b>New members list</b> found at<br>%s<br>with %s members.</p>';
    $de['newlist_foundat']      = '<p><b>Neue Mitgliederlister</b> gefunden unter<br>%s<br>mit %s Mitgliedern.</p>';
    $en['newlog_foundat']       = '<p>New log file of %s Byte found.</p>';
    $de['newlog_foundat']       = '<p>Neue Logdatei von %s Byte Umfang gefunden.</p>';
    $en['emptylist_exists']     = '<p>Empty new members file exists already.</p>';
    $de['emptylist_exists']     = '<p>Leere neue Mitgliederdatei besteht bereits.</p>';
    $en['nonewlist_found']      = '<p>No new members file found</p>';
    $de['nonewlist_found']      = '<p>Keine neue Mitgliederliste gefunden.</p>';
    $en['oldlist_fountat']      = '<p><b>Old members list</b> found at';
    $de['oldlist_fountat']      = '<p><b>Alte Mitgliederliste</b> gefunden unter';
    $en['with_members']         = 'with %s members</p>';
    $de['with_members']         = 'mit %s Mitgliedern.</p>';
    $en['oldlog_found']         = '<p>Old log file of %s Byte found.</p>';
    $de['oldlog_found']         = '<p>Alte Logdatei von %s Byte Umfang gefunden.</p>';
    $en['info_old_permis']      = '<p>(Writing permissions for the old members\' list are only relevant,
                                   if you want to put your new members\' file in the old folder and not
                                   in the new default folder <br>./userfiles/plugins/memberpages/)</p>';
    $de['info_old_permis']      = '<p>(Schreibrechte für die alte Mitgliederliste sind nur von Bedeutung,
                                   wenn man die neue Mitgliederliste im bisherigen Ordner der alten Liste speichern will
                                   und nicht im neuen Standardordner <br>./userfiles/plugins/memberpages/)</p>';
    $en['info_changefolder']    = 'You can change the folder path to the old location if you think that\'s better.';
    $de['info_changefolder']    = 'Sie können als Pfad zur Mitgliederliste den Pfad zur alten Mitgliederliste einstellen,
                                   wenn Ihnen das besser als der Standardpfad erscheint.';
    $en['changeto_oldloc']      = 'Change folder path to the old location';
    $de['changeto_oldloc']      = 'Pfad ändern zu Pfad zum alten Speicherort';
    $en['info_anylocation']     = 'You can also change the folder
                                   to any other location. While changing the folder location the plugin will
                                   not move any lists but start a new list.';
    $de['info_anylocation']     = 'Sie können auch einen ganz anderen Pfad für den Speicherort der Mitgliederliste
                                   wählen. Wenn Sie einen neuen Pfad hier eingeben, wird
                                   unter dem neuen Pfad eine neue Liste angelegt. (Der Pfad ist jederzeit änderbar.)';
    $en['change_toanylocation'] =  'Change folder path to above location';
    $de['change_toanylocation'] =  'Pfad auf angegebenen Pfad ändern';
    $en['import_oldlist']       = 'If all permissions for the choosen folder location are OK
                                   you can import your old list and log file.
                                   (Any new list and log at that location will be overwritten.)';
    $de['import_oldlist']       = 'Wenn alle Schreibrechte für den ausgewählten Speicherort passen,
                                   können die alte Mitgliederliste und die Logdatei importiert werden.
                                   (Eventuell an diesem Speicherort vorhandene neue Mitgliederliste und Logdatei werden überschrieben.)';
    $en['import_oldlistandlog'] = 'Import old list and log';
    $de['import_oldlistandlog'] = 'Alte Mitgliederliste und Logdatei importieren';

    $tx = $sl=='de'? $de : $en;

    if(isset($_POST['import'])) {
        $member = memberpages_GetOldList();
        $logsize = filesize($pth['folder']['plugins'] . 'memberpages/logfile/logfile.txt');
        if($logsize) {
            $logfile = file_get_contents($pth['folder']['plugins'] . 'memberpages/logfile/logfile.txt');
            $i = file_put_contents(MEMBERSFILEPATH . 'log.txt',$logfile);
            $text .= $i
                   ? '<p>' . $i . $tx['logfile_bytesimport']
                   : '<p>' . $tx['error_logfileimport'];
        }
        if(memberpages_SaveList($member)) {
            $text .= $tx['memberlist_importok'];
        } else $text .= '<p class="error">'. $tx['err_memberlistimport'] .'</p>';
    }

    $config = file_get_contents($pth['folder']['plugins'] . 'memberpages/config/config.php');
    $config = rtrim($config,"\n\r>?")."\n";

    if(isset($plugin_cf['memberpages']['usecsvfile']) && $plugin_cf['memberpages']['usecsvfile']) {
        $olddir = substr($plugin_cf['memberpages']['cssfile'],0,
                  strrpos($plugin_cf['memberpages']['cssfile'], '/')+1);
    } else {
        $olddir = substr(memberpages_SearchPhpList(),0,
                  strrpos(memberpages_SearchPhpList(), '/')+1);
    }


    if(isset($_POST['changeToOldDir'])) {
        $config .= '$plugin_cf[\'memberpages\'][\'membersfilepath\']="'
                . $olddir . '";' . "\n";
        if(file_put_contents($pth['folder']['plugins'] . 'memberpages/config/config.php', $config, LOCK_EX)) {
            $message .= $tx['oldpath_now_newpath'];
        } else $message .= $tx['err_oldpath_newpath'];
        setcookie('mmp_pluginActivation', $message, time()+2);
        header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_main');
        exit;
    }

    if(isset($_POST['newDir'])) {
        $config .= '$plugin_cf[\'memberpages\'][\'membersfilepath\']="'
                . $_POST['newDir'] . '";' . "\n";
        if(file_put_contents($pth['folder']['plugins'] . 'memberpages/config/config.php', $config, LOCK_EX)) {
            $message .= $tx['path_memlistchanged'] . $_POST['newDir'] . '</p>';
        } else $message .= $tx['err_path_listchange'];
        setcookie('mmp_pluginActivation', $message, time()+2);
        header('Location: '.CMSIMPLE_URL.'?&memberpages&admin=plugin_main');
        exit;
    }

    if(isset($_POST['activate'])) {
        memberpages_SaveConfig();
        memberpages_ProcessList();
    }

// ===================================
// Standard dialog plugin activation
// ===================================


        if(isset($_COOKIE['mmp_pluginActivation'])) $text .= $_COOKIE['mmp_pluginActivation'];

        $text .= '<h1>Memberpages ' . MEMBERPAGES_VERSION . tag('br')
              . $tx['activation_alert']
              . '</h1>';

        $text .= '<p>'.$tx['activation_explained'].'</p>'
              . '<form action="" method="POST">'
              . '<button type="submit" name="activate"
                style="font-weight:bold;padding:0 1em;letter-spacing:.05em;" value="1">'
              . $tx['activation_click_here']
              . '</button>'
              . '</form>' . tag('br');

        $text .= $tx['details_explained']
               .  MEMBERSFILEPATH;
        $text .=  MEMBERSFILEPATH == $pth['folder']['userfiles'].'plugins/memberpages/'
               ? $tx['standard_location']
               : $tx['changed_location'];
        $text .=  memberpages_CheckPermissions();

        $text .=  tag('hr');
        // new files found
        if(is_file(MEMBERSFILEPATH.'membersfile.php')) {
            $member = parse_ini_file(MEMBERSFILEPATH.'membersfile.php',true);
            if(count($member)>0
                && isset($member['0']['user'])
                && isset($member['0']['pass'])) {
                $text .= sprintf($tx['newlist_foundat'], MEMBERSFILEPATH, count($member));
                $newlogsize = filesize(MEMBERSFILEPATH . 'log.txt');
                if($newlogsize) $text .= sprintf($tx['newlog_foundat'], $newlogsize);
            } else $text .= $tx['emptylist_exists'];
        } else $text .= $de['nonewlist_found'];

        $text .= tag('hr');

        // old files found
        if($oldmember = memberpages_GetOldList()) {
            $text .= tag('hr');
            $text .= $tx['oldlist_fountat'] . tag('br');

            $text .= isset($plugin_cf['memberpages']['usecsvfile']) && $plugin_cf['memberpages']['usecsvfile']
                  ?  $pth['folder']['base'].$plugin_cf['memberpages']['csvfile']
                  :  memberpages_SearchPhpList();
            $text .= tag('br') .sprintf($de['with_members'], count($oldmember));

            $logsize = filesize($pth['folder']['plugins'] . 'memberpages/logfile/logfile.txt');
            if($logsize) $text .= sprintf($tx['oldlog_found'],$logsize);

            $text .= memberpages_CheckPermissions($olddir);
            $text .= $tx['info_old_permis'];
            $text .= tag('hr');

            $text .= tag('br');

            // Change path to old location
            if(trim(MEMBERSFILEPATH,'./') != trim($olddir,'./'))
                $text .= '<form action="" method="POST">' . $tx['info_changefolder']
                       . '<button type="text" name="changeToOldDir"
                         value="'.$olddir.'">'.$tx['changeto_oldloc']
                       . tag('br') . $olddir . '</button></form>'. tag('br');
        }

        // change path to any location
        $text .= '<form action="" method="POST">' . $tx['info_anylocation'] 
               . tag('input type="text" name="newDir" value="./"')
               . '<button type="submit">' . $tx['change_toanylocation']
               . '</button></form>'. tag('br');

        if($oldmember) $text .= '<form action="" method="POST">'.$tx['import_oldlist']
                          . '<button type="text" name="import"
                             value="1">'. $tx['import_oldlistandlog'] . '</button></form>';

        $text .= tag('br');



    // Wrapper for activation messages
    $o .=  '<div class="membp_update"><div>'
        . $text
        . '</div></div>';

    return $o;
}


function memberpages_CheckFile($file)
{
    $o = array('missing'=>'','notwritable'=>'');

    if(!is_file($file) && !ini_get('safe_mode')) file_put_contents($file,'');
    if(!is_file($file)) $o['missing'] .=  $file . tag('br');
    elseif(!is_writable($file)) {
        $o['notwritable'] .=  $file . tag('br');
    }
    return $o;
}



function memberpages_CheckPermissions($path='')
{
    global $pth,$tx,$sl;
    $o = '';

    $en = $de = array();
    $en['ok']   = '<p>Folder settings and writing permissions: OK</p>';
    $de['ok']   = '<p>Ordnereinstellungen und Schreibrechte in Ordnung.</p>';
    $en['info_savemode'] = '<p class="error">PHP-setting <b>save_mode=on</b> detected.</p><p>Save-mode
                 prevents php from creating writable folders and may prevent creating files.
                 In order to get writable folders you have to upload the folders via ftp.</p>'
               .'<p><u>How to proceed:</u><br>To create standard user folder upload the unzipped
                 memberpages_userfiles.zip to your CMSimple_XH installation. <br />
                 Alternatively create empty folders with the wanted name on your home computer and
                 upload these empty folders via ftp to the correct place in your website.
                 Then give writing permissions.</p>';
    $de['info_savemode'] = '<p class="error">PHP-Einstellung <b>save_mode=on</b> festgestellt.</p><p>Save-mode
                 verhindert, dass per PHP-Anweisung Ordner mit einstellbaren Schreibrechten erstellt werden. Auch das
                 Erstellen von Dateien ist eingeschränkt.
                 Um schreibbare Ordner zu erhalten müssen diese per FTP hochgeladen werden, andernfalls haben sie
                 den falschen Besitzer und unbenutzbar.</p>'
               .'<p><u>Wie vorzugehen ist:</u><br>Wenn Sie Ihre Daten im Standard-Userfiles-Ordner speichern, ist es am
                 einfachsten die entpackte memberpages_userfiles.zip auf ihr Basisverzeichnis zu kopieren.
                 Alternativ gewünschte Ordner erst auf dem eigenen PC anlegen, und 
                 anschließend mit FTP an die richtige Stelle hochladen.
                 Danach auf jedenfall immer Schreibrechte vergeben.</p>';
    $en['no-apache'] = '<p>Your server is not Apache, and .htaccess protection may not work.
               Please secure your folder <b>%s</b> agains external access.</p>';
    $de['no-apache'] = '<p>Ihr Server läuft nicht unter Apache und deshalb wirkt der .htaccess-Schutz eventuell nicht.
               Schützen Sie daher den Ordner <b>%s</b> gegen Frendzugriff entsprechend.</p>';

    $t = $sl=='de'? $de : $en;


    $error = memberpages_CheckFile($pth['folder']['plugins'].'memberpages/config/config.php');
    if(!$path) $path = MEMBERSFILEPATH;
    if(!is_dir($path) && !ini_get('safe_mode')) mkdir($path, 0755, true);
    if(!is_dir($path)) {
        $error['missing'] .=  $path . tag('br');
    }
    elseif(!is_writable($path)) {
        $error['notwritable'] .= $path . tag('br');
    }

    $x = memberpages_CheckFile($path.'log.txt');
    $error['notwritable'] .= $x['notwritable'];
    $error['missing'] .= $x['missing'];


    $x = memberpages_CheckFile($path.'membersfile.php');
    $error['notwritable'] .= $x['notwritable'];
    $error['missing'] .= $x['missing'];
    if(!is_file($path.'membersfile.php') || filesize($path.'membersfile.php') < 10)
        file_put_contents($path.'membersfile.php',
         ';<?php' . PHP_EOL . ';die();' . PHP_EOL . ';/*' . PHP_EOL);

    if(!is_file($path.'.htaccess') || filesize($path.'.htaccess') < 10)
        file_put_contents($path.'.htaccess',
        'order deny,allow' . "\n" . 'deny from all' . "\n");
    $x = memberpages_CheckFile($path.'.htaccess');
    $error['notwritable'] .= $x['notwritable'];
    $error['missing'] .= $x['missing'];

    $server = strtolower( $_SERVER["SERVER_SOFTWARE"] );
    if (strpos($server, "apache") === false ) {
        $o .= sprintf($t['no-apache'],$path);
    }

    if($error['missing']) {
        $o .= '<div class="error"><u>'. $tx['error']['missing'] .':</u>'. tag('br') . $error['missing'] . '</div>';
        if( ini_get('safe_mode') ){
            $o .= $t['info_savemode'];
        }
    }
    if($error['notwritable']) $o .= '<div class="error"><u>'. $tx['error']['notwritable']
                                  . ':</u>'. tag('br') . $error['notwritable'] . '</div>';

    return $o? $o : $t['ok'];
}



function memberpages_GetOldList()
{
    global $plugin_cf,$pth,$tx,$plugin_tx;

    if($plugin_cf['memberpages']['usecsvfile'])
    {
        $user = $exuser = $pass = $expass = $access = $email = $fullname = $expires = array();

        $array = file($pth['folder']['base'] . $plugin_cf['memberpages']['csvfile']);

        foreach($array as $key => $value) {
            $data = explode(',', $array[$key]);
            $x = mb_strlen($data[1],'UTF-8')>4? 1 : '';
            list($year,$month,$day) = explode('-',trim($data[5]));
            $expires = mktime(0,0,0,$month,$day,$year);
        	$member[$key] = array(
                'user'   =>$data[0],
                'pass'   =>$data[1],
                'access' =>$data[2],
                'email'  =>trim($data[3]),
                'full'   =>trim($data[4]),
                'expires'=>$expires,
                'x'      =>$x
                );
        }
    }
    else
    {
        if(!$list = memberpages_SearchPhpList()) {
            return false;

        } else {

            include $list;

            $user     = explode(",", $members['user_array']);
            $pass     = explode(",", $members['pass_array']);
            $access   = explode(",", $members['accesslevel_array']);
            $email    = explode(",", $members['email_array']);
            $full     = explode(",", $members['fullname_array']);
            $expires  = explode(",", $members['expires_array']);
            foreach ($user as $key=>$value) {
                $x = mb_strlen($pass[$key],'UTF-8')>4? 1 : '';
                if($expires[$key]) {
                    list($year,$month,$day) = explode('-',$expires[$key]);
                    $expires[$key] = mktime(0,0,0,$month,$day,$year);
                } else $expires[$key] = '';

            	$member[$key] = array(
                    'user'   =>$user[$key],
                    'pass'   =>$pass[$key],
                    'access' =>$access[$key],
                    'email'  =>$email[$key],
                    'full'   =>$full[$key],
                    'expires'=>$expires[$key],
                    'x'      =>$x
                    );
            }
        }
    }
    return $member;
}

function memberpages_SearchPhpList()
{
    global $pth,$plugin_cf;

    if(!isset($plugin_cf['memberpages']['phpfile']) || !$plugin_cf['memberpages']['phpfile']) {
        if(is_file($pth['folder']['plugins'].'memberpages/data/memberslist.php')) {
            $list = $pth['folder']['plugins'].'memberpages/data/memberslist.php';
        }
        if(is_file($pth['folder']['plugins'].'memberpages/data/memberlist.php')) {
            $list = $pth['folder']['plugins'].'memberpages/data/memberlist.php';
        } else $list = false;
    } else $list = $pth['folder']['base'] . $plugin_cf['memberpages']['phpfile'];

    return $list;
}
